USE [master]
GO
/****** Object:  Database [TechNetDB]    Script Date: 4/03/2019 6:10:09 PM ******/
CREATE DATABASE [TechNetDB]
 CONTAINMENT = NONE
 ON  PRIMARY 
( NAME = N'TechNetDB', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL13.SQLEXPRESS\MSSQL\DATA\TechNetDB.mdf' , SIZE = 8192KB , MAXSIZE = UNLIMITED, FILEGROWTH = 65536KB )
 LOG ON 
( NAME = N'TechNetDB_log', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL13.SQLEXPRESS\MSSQL\DATA\TechNetDB_log.ldf' , SIZE = 8192KB , MAXSIZE = 2048GB , FILEGROWTH = 65536KB )
GO
ALTER DATABASE [TechNetDB] SET COMPATIBILITY_LEVEL = 130
GO
IF (1 = FULLTEXTSERVICEPROPERTY('IsFullTextInstalled'))
begin
EXEC [TechNetDB].[dbo].[sp_fulltext_database] @action = 'enable'
end
GO
ALTER DATABASE [TechNetDB] SET ANSI_NULL_DEFAULT OFF 
GO
ALTER DATABASE [TechNetDB] SET ANSI_NULLS OFF 
GO
ALTER DATABASE [TechNetDB] SET ANSI_PADDING OFF 
GO
ALTER DATABASE [TechNetDB] SET ANSI_WARNINGS OFF 
GO
ALTER DATABASE [TechNetDB] SET ARITHABORT OFF 
GO
ALTER DATABASE [TechNetDB] SET AUTO_CLOSE OFF 
GO
ALTER DATABASE [TechNetDB] SET AUTO_SHRINK OFF 
GO
ALTER DATABASE [TechNetDB] SET AUTO_UPDATE_STATISTICS ON 
GO
ALTER DATABASE [TechNetDB] SET CURSOR_CLOSE_ON_COMMIT OFF 
GO
ALTER DATABASE [TechNetDB] SET CURSOR_DEFAULT  GLOBAL 
GO
ALTER DATABASE [TechNetDB] SET CONCAT_NULL_YIELDS_NULL OFF 
GO
ALTER DATABASE [TechNetDB] SET NUMERIC_ROUNDABORT OFF 
GO
ALTER DATABASE [TechNetDB] SET QUOTED_IDENTIFIER OFF 
GO
ALTER DATABASE [TechNetDB] SET RECURSIVE_TRIGGERS OFF 
GO
ALTER DATABASE [TechNetDB] SET  DISABLE_BROKER 
GO
ALTER DATABASE [TechNetDB] SET AUTO_UPDATE_STATISTICS_ASYNC OFF 
GO
ALTER DATABASE [TechNetDB] SET DATE_CORRELATION_OPTIMIZATION OFF 
GO
ALTER DATABASE [TechNetDB] SET TRUSTWORTHY OFF 
GO
ALTER DATABASE [TechNetDB] SET ALLOW_SNAPSHOT_ISOLATION OFF 
GO
ALTER DATABASE [TechNetDB] SET PARAMETERIZATION SIMPLE 
GO
ALTER DATABASE [TechNetDB] SET READ_COMMITTED_SNAPSHOT OFF 
GO
ALTER DATABASE [TechNetDB] SET HONOR_BROKER_PRIORITY OFF 
GO
ALTER DATABASE [TechNetDB] SET RECOVERY SIMPLE 
GO
ALTER DATABASE [TechNetDB] SET  MULTI_USER 
GO
ALTER DATABASE [TechNetDB] SET PAGE_VERIFY CHECKSUM  
GO
ALTER DATABASE [TechNetDB] SET DB_CHAINING OFF 
GO
ALTER DATABASE [TechNetDB] SET FILESTREAM( NON_TRANSACTED_ACCESS = OFF ) 
GO
ALTER DATABASE [TechNetDB] SET TARGET_RECOVERY_TIME = 60 SECONDS 
GO
ALTER DATABASE [TechNetDB] SET DELAYED_DURABILITY = DISABLED 
GO
ALTER DATABASE [TechNetDB] SET QUERY_STORE = OFF
GO
USE [TechNetDB]
GO
ALTER DATABASE SCOPED CONFIGURATION SET LEGACY_CARDINALITY_ESTIMATION = OFF;
GO
ALTER DATABASE SCOPED CONFIGURATION SET MAXDOP = 0;
GO
ALTER DATABASE SCOPED CONFIGURATION SET PARAMETER_SNIFFING = ON;
GO
ALTER DATABASE SCOPED CONFIGURATION SET QUERY_OPTIMIZER_HOTFIXES = OFF;
GO
USE [TechNetDB]
GO
/****** Object:  Table [dbo].[Location]    Script Date: 4/03/2019 6:10:09 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Location](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Latitude] [float] NOT NULL,
	[Longitude] [float] NOT NULL,
 CONSTRAINT [PK_Location] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[SpatialObject]    Script Date: 4/03/2019 6:10:09 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[SpatialObject](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Name] [nvarchar](50) NOT NULL,
	[Description] [nvarchar](250) NULL,
	[LocationId] [int] NOT NULL,
 CONSTRAINT [PK_SpatialObject] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[SpatialObjectDocument]    Script Date: 4/03/2019 6:10:10 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[SpatialObjectDocument](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[SpatialObjectId] [int] NOT NULL,
	[DocName] [nvarchar](100) NOT NULL,
	[DocUrl] [nvarchar](150) NOT NULL,
 CONSTRAINT [PK_SpatialObjectDocument] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[SpatialObjectReadModel]    Script Date: 4/03/2019 6:10:10 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[SpatialObjectReadModel](
	[Id] [int] NOT NULL,
	[Name] [nvarchar](50) NOT NULL,
	[Description] [nvarchar](250) NULL,
	[Latitude] [float] NOT NULL,
	[Longitude] [float] NOT NULL,
 CONSTRAINT [PK_SpatialObjectReadModel] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
ALTER TABLE [dbo].[SpatialObject]  WITH CHECK ADD  CONSTRAINT [FK_SpatialObject_Location] FOREIGN KEY([LocationId])
REFERENCES [dbo].[Location] ([Id])
GO
ALTER TABLE [dbo].[SpatialObject] CHECK CONSTRAINT [FK_SpatialObject_Location]
GO
ALTER TABLE [dbo].[SpatialObjectDocument]  WITH CHECK ADD  CONSTRAINT [FK_SpatialObjectDocument_SpatialObject] FOREIGN KEY([SpatialObjectId])
REFERENCES [dbo].[SpatialObject] ([Id])
GO
ALTER TABLE [dbo].[SpatialObjectDocument] CHECK CONSTRAINT [FK_SpatialObjectDocument_SpatialObject]
GO
/****** Object:  StoredProcedure [dbo].[sp_GetGeographyDistance]    Script Date: 4/03/2019 6:10:10 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		Haviv Tzin
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [dbo].[sp_GetGeographyDistance]
	 @FromLatitude float,
	 @FromLongitude float,
	 @ToLatitude float,
	 @ToLongitude float
AS
BEGIN
	SET NOCOUNT ON;

    -- Insert statements for procedure here
    DECLARE @FromPoint geography;
	SET @FromPoint = GEOGRAPHY::STGeomFromText('Point(' + CAST(@FromLongitude AS VARCHAR(32)) + ' ' + CAST(@FromLatitude AS VARCHAR(32)) + ')',4326)
	
    DECLARE @ToPoint geography;
	SET @ToPoint = GEOGRAPHY::STGeomFromText('Point(' + CAST(@ToLongitude AS VARCHAR(32)) + ' ' + CAST(@ToLatitude AS VARCHAR(32)) + ')',4326)

	SELECT ROUND( @FromPoint.STDistance(@ToPoint),0,0)
END
GO
USE [master]
GO
ALTER DATABASE [TechNetDB] SET  READ_WRITE 
GO
